<?php

class ControllerExtensionPaymentPrimepayments extends Controller {
	private $error = array();

	public function index() {
		$this->load->language( 'extension/payment/primepayments' );

		$this->document->setTitle( $this->language->get( 'heading_title' ) );

		$this->load->model( 'setting/setting' );

		if ( ( $this->request->server['REQUEST_METHOD'] == 'POST' ) && $this->validate() ) {
			$this->model_setting_setting->editSetting( 'payment_primepayments', $this->request->post );

			$this->session->data['success'] = $this->language->get( 'text_success' );

			$this->response->redirect( $this->url->link( 'marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true ) );
		}

		if ( isset( $this->error['warning'] ) ) {
			$data['error_warning'] = $this->error['warning'];
		}
		else {
			$data['error_warning'] = '';
		}

		if ( isset( $this->error['merchant'] ) ) {
			$data['error_merchant'] = $this->error['merchant'];
		}
		else {
			$data['error_merchant'] = '';
		}

		if ( isset( $this->error['signature'] ) ) {
			$data['error_signature'] = $this->error['signature'];
		}
		else {
			$data['error_signature'] = '';
		}

		if ( isset( $this->error['type'] ) ) {
			$data['error_type'] = $this->error['type'];
		}
		else {
			$data['error_type'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get( 'text_home' ),
			'href' => $this->url->link( 'common/dashboard', 'user_token=' . $this->session->data['user_token'], true )
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get( 'text_extension' ),
			'href' => $this->url->link( 'marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true )
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get( 'heading_title' ),
			'href' => $this->url->link( 'extension/payment/primepayments', 'user_token=' . $this->session->data['user_token'], true )
		);

		$data['action'] = $this->url->link( 'extension/payment/primepayments', 'user_token=' . $this->session->data['user_token'], true );

		$data['cancel'] = $this->url->link( 'marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true );


		// =======================================================================
		// Merchant ID
		// =======================================================================
		$merchant_key = 'payment_primepayments_merchant';
		if ( isset( $this->request->post[ $merchant_key ] ) ) {
			$data[ $merchant_key ] = $this->request->post[ $merchant_key ];
		}
		else {
			$data[ $merchant_key ] = $this->config->get( $merchant_key );
		}

		// =======================================================================
		// Secret key 1
		// =======================================================================
		$secret_1_key = 'payment_primepayments_secret_1';
		if ( isset( $this->request->post[ $secret_1_key ] ) ) {
			$data[ $secret_1_key ] = $this->request->post[ $secret_1_key ];
		}
		else {
			$data[ $secret_1_key ] = $this->config->get( $secret_1_key );
		}

		// =======================================================================
		// Secret key 2
		// =======================================================================
		$secret_2_key = 'payment_primepayments_secret_2';
		if ( isset( $this->request->post[ $secret_2_key ] ) ) {
			$data[ $secret_2_key ] = $this->request->post[ $secret_2_key ];
		}
		else {
			$data[ $secret_2_key ] = $this->config->get( $secret_2_key );
		}

		// =======================================================================
		// Payments type
		// =======================================================================
		if ( isset( $this->request->post['payment_primepayments_type'] ) ) {
			$data['payment_primepayments_type'] = $this->request->post['payment_primepayments_type'];
		}
		else {
			$data['payment_primepayments_type'] = $this->config->get( 'payment_primepayments_type' );
		}

		// =======================================================================
		// Order status
		// =======================================================================
		if ( isset( $this->request->post['payment_primepayments_order_status_id'] ) ) {
			$data['payment_primepayments_order_status_id'] = $this->request->post['payment_primepayments_order_status_id'];
		}
		else {
			$data['payment_primepayments_order_status_id'] = $this->config->get( 'payment_primepayments_order_status_id' );
		}

		// =======================================================================
		// Gateway name
		// =======================================================================
		if ( isset( $this->request->post['payment_primepayments_gateway_name'] ) ) {
			$data['payment_primepayments_gateway_name'] = $this->request->post['payment_primepayments_gateway_name'];
		}
		else {
			$data['payment_primepayments_gateway_name'] = $this->config->get( 'payment_primepayments_gateway_name' );
		}

		$data['site_url'] = HTTPS_CATALOG;

		$this->load->model( 'localisation/order_status' );

		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

		// =======================================================================
		// GEO zones
		// =======================================================================
		if ( isset( $this->request->post['payment_primepayments_geo_zone_id'] ) ) {
			$data['payment_primepayments_geo_zone_id'] = $this->request->post['payment_primepayments_geo_zone_id'];
		}
		else {
			$data['payment_primepayments_geo_zone_id'] = $this->config->get( 'payment_primepayments_geo_zone_id' );
		}

		$this->load->model( 'localisation/geo_zone' );

		$data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();

		if ( isset( $this->request->post['payment_primepayments_status'] ) ) {
			$data['payment_primepayments_status'] = $this->request->post['payment_primepayments_status'];
		}
		else {
			$data['payment_primepayments_status'] = $this->config->get( 'payment_primepayments_status' );
		}

		$data['header'] = $this->load->controller( 'common/header' );
		$data['column_left'] = $this->load->controller( 'common/column_left' );
		$data['footer'] = $this->load->controller( 'common/footer' );

		$this->response->setOutput( $this->load->view( 'extension/payment/primepayments', $data ) );
	}

	protected function validate() {
		if ( ! $this->user->hasPermission( 'modify', 'extension/payment/primepayments' ) ) {
			$this->error['warning'] = $this->language->get( 'error_permission' );
		}

		if ( ! $this->request->post['payment_primepayments_merchant'] ) {
			$this->error['merchant'] = $this->language->get( 'error_merchant' );
		}

		if ( ! $this->request->post['payment_primepayments_secret_1'] ) {
			$this->error['error_secret_1'] = $this->language->get( 'error_secret_1_message' );
		}

		if ( ! $this->request->post['payment_primepayments_secret_2'] ) {
			$this->error['error_secret_2'] = $this->language->get( 'error_secret_2_message' );
		}

		return ! $this->error;
	}
}