<?php

class ControllerExtensionPaymentPrimepayments extends Controller {
	public function index() {
		if (
			isset( $this->request->request ) &&
			isset( $this->request->request['route'] ) &&
			$this->request->request['route'] == 'checkout/success'
		) {
			return;
		}

		$data['button_confirm'] = $this->language->get( 'button_confirm' );

		$this->load->model( 'checkout/order' );
		$this->load->model( 'localisation/currency' );

		$order_info = $this->model_checkout_order->getOrder( $this->session->data['order_id'] );

		$allowed_currencies = array('USD', 'RUB', 'EUR');

		$order_id	= $this->session->data['order_id'];
		$price 		= $order_info['total'];
		$currency 	= $order_info['currency_code'];

		if( ! in_array( $currency, $allowed_currencies ) ){
			$this->load->language( 'extension/payment/primepayments' );
			return $this->load->view( 'extension/payment/primepayments', array(
				'status'	=> 'BAD',
				'message'	=> $this->language->get('currency_error'),
			) );
		}

		$api_url	= 'https://pay.primepayments.ru/API/v1/';

		$project_id = $this->config->get( 'payment_primepayments_merchant' );
		$secret_1 	= $this->config->get( 'payment_primepayments_secret_1' );

		$args = array(
			'action' 			=> 'initPayment',
			'project'			=> $project_id,
			'sum'				=> $price,
			'currency'			=> $currency,
			'email'				=> $order_info['email'],
			'payWay'			=> 0,
			'innerID'			=> $order_id,
			//'returnLink'		=> 1,
			'needFailNotice'	=> 1,
			'lang'				=> strtoupper( $this->language->get('code') ),
			'sign'				=> md5( $secret_1 . 'initPayment' . $project_id . $price . $currency . $order_id . $order_info['email'] . 0),
		);

		return $this->load->view( 'extension/payment/primepayments', array(
			'args'		=> $args,
			'action'	=> $api_url,
		) );
	}

	public function callback() {
		//=========================================================
		// Handle PAYED callback webhook from PrimePayments
		//=========================================================
		$secret_2 = $this->config->get( 'payment_primepayments_secret_2' );

		if( $_REQUEST['action'] === 'order_payed' ) {
			// Validate sign
			$sign = md5( $secret_2 . $_REQUEST['orderID'] . $_REQUEST['payWay'] . $_REQUEST['innerID'] . $_REQUEST['sum'] . $_REQUEST['webmaster_profit'] );

			//TODO: Handle unsigned requests
			if ( $sign !== $_REQUEST['sign'] ) {
				echo 'Incorrect signature! Check the secret words in the settings.';
				exit;
			};

			//$this->log->write( 'Incomed request' );
			if ( $this->request->post['action'] === 'order_payed' ) {
				$this->load->model( 'checkout/order' );
				$this->model_checkout_order->addOrderHistory( $_REQUEST['innerID'], $this->config->get( 'payment_primepayments_order_status_id' ) );

				echo 'OK';
				exit;
			}
		}

		else if( $_REQUEST['action'] === 'order_cancel' ){
			$sign = md5( $secret_2 . $_REQUEST['orderID'] . $_REQUEST['innerID'] );

			if( $sign !== $_REQUEST['sign'] ){
				echo 'Incorrect signature! Check the secret words in the settings.';
				exit;
			};

			//На наш запрос сайт должен ответить "OK" (англ. символы, без кавычек)
			echo 'OK';
		}
	}
}
